'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Wrapper = exports.cleanProps = exports.zipLeaving = exports.nextReducer = exports.triggerForceUpdates = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var values = Object.values;
var max = Math.max;
var triggerForceUpdates = exports.triggerForceUpdates = (0, _recompose.withStateHandlers)({ updates: 0 }, {
  forceUpdate: function forceUpdate(_ref) {
    var updates = _ref.updates;
    return function () {
      return { updates: updates + 1 };
    };
  }
});

var nextReducer = exports.nextReducer = function nextReducer(acc, child) {
  return _extends({}, acc, _defineProperty({}, child.key, child));
};

var iter = function iter(limit, fn) {
  for (var i = 0; i <= limit; i++) {
    fn(i);
  }
};

var zip = function zip(into, first, second) {
  return function (i) {
    first[i] && into.push(first[i]);
    second[i] && into.push(second[i]);
  };
};

var nextFreeIndex = function nextFreeIndex(map, index) {
  var nextSafeIndex = -1;
  var count = 1;
  while (nextSafeIndex < 0) {
    nextSafeIndex = !map[index] ? index : !map[index + count++] ? index + count : nextSafeIndex;
  }
  return nextSafeIndex;
};

var zipLeaving = exports.zipLeaving = function zipLeaving(_ref2) {
  var leaving = _ref2.leaving,
      children = _ref2.children;

  var currentChildren = _react.Children.toArray(children);
  var allChildren = [];
  var currentKeys = currentChildren.map(function (_ref3) {
    var key = _ref3.key;
    return key;
  });
  var maxIndex = currentChildren.length;
  var offset = 0;

  var leavingMap = values(leaving()).reduce(function (acc, _ref4) {
    var child = _ref4.child,
        index = _ref4.index;

    if (currentKeys.includes(child.key)) return acc;

    var insertAt = nextFreeIndex(acc, index + offset);

    maxIndex = max(insertAt, maxIndex);
    offset = insertAt - index;
    return _extends({}, acc, _defineProperty({}, insertAt, child));
  }, {});

  iter(maxIndex, zip(allChildren, leavingMap, currentChildren));

  return {
    children: allChildren
  };
};

var cleanProps = (0, _recompose.mapProps)(function (_ref5) {
  var updates = _ref5.updates,
      forceUpdate = _ref5.forceUpdate,
      setLeaving = _ref5.setLeaving,
      setLeft = _ref5.setLeft,
      setJustEntered = _ref5.setJustEntered,
      props = _objectWithoutProperties(_ref5, ['updates', 'forceUpdate', 'setLeaving', 'setLeft', 'setJustEntered']);

  return props;
});

exports.cleanProps = cleanProps;
var Wrapper = function Wrapper(_ref6) {
  var _ref6$As = _ref6.As,
      As = _ref6$As === undefined ? _react2.default.Fragment || 'div' : _ref6$As,
      children = _ref6.children,
      props = _objectWithoutProperties(_ref6, ['As', 'children']);

  return _react2.default.createElement(
    As,
    props,
    children
  );
};
exports.Wrapper = Wrapper;